package net.t2code.t2codelib.SPIGOT.system.config.config;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigEnumManager;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriter;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.T2CconfigItem;
import net.t2code.t2codelib.Util;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class ConfigCreate {

    /**
    public enum VALUES implements T2CconfigItem {
        updateCheckOnJoin("plugin.updateCheck.onJoin", true),
        updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60),
        seePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true),
        updateCheckFullDisable("plugin.updateCheck.allPlugins.FullDisable", false),
        debug("plugin.debug.debugModus", false),
        developerTool("plugin.debug.developerTool", true),
        language("plugin.language", "english"),
        bungee("proxy.enable", T2CodeLibMain.getIsBungee()),
        inventoriesCloseByServerStop("player.inventories.closeByServerStop", true),
        commandPermToggleCommand("command.permToggle.permissionSetCommand", "lp user [player] permission set [perm] [value]"),

        ;

        private final String key;
        private Object value;
        private final List<String> comments;

        VALUES(String key, Object value, String... comments) {
            this.key = key;
            this.value = value;
            this.comments = new ArrayList<>(Arrays.asList(comments));
        }

        @Override
        public String getKey() {
            return key;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public List<String> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

*/
    public static final T2CconfigEnumManager manager = new T2CconfigEnumManager();


    public static void set() {
        long long_ = System.currentTimeMillis();

        manager.addOrChangeEnum(ConfigKey.updateCheckOnJoin, "plugin.updateCheck.onJoin", true);
        manager.addOrChangeEnum(ConfigKey.updateCheckTimeInterval, "plugin.updateCheck.timeInterval", 60);
        manager.addOrChangeEnum(ConfigKey.seePreReleaseUpdates, "plugin.updateCheck.seePreReleaseUpdates", true);
        manager.addOrChangeEnum(ConfigKey.updateCheckFullDisable, "plugin.updateCheck.allPlugins.FullDisable", false);
        manager.addOrChangeEnum(ConfigKey.debug, "plugin.debug.debugModus", false);
        manager.addOrChangeEnum(ConfigKey.developerTool, "plugin.debug.developerTool", true);
        manager.addOrChangeEnum(ConfigKey.language, "plugin.language", "english");
        manager.addOrChangeEnum(ConfigKey.bungee, "proxy.enable", T2CodeLibMain.getIsBungee());
        manager.addOrChangeEnum(ConfigKey.inventoriesCloseByServerStop, "player.inventories.closeByServerStop", true);
        manager.addOrChangeEnum(ConfigKey.commandPermToggleCommand, "command.permToggle.permissionSetCommand", "lp user [player] permission set [perm] [value]");

        T2CconfigWriter.createConfig(new File(T2CodeLibMain.getPath(), "config.yml"), manager.getAllEnums(), "PL von", "Jattitv");
        T2CconfigWriter.createConfig(new File(T2CodeLibMain.getPath(), "config.yml"), VALUES.values(), "PL von", "Jattitv");

                T2Csend.console(Util.getPrefix() + " §2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }
}
